<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <!-- Import DataTable Library -->
  <!-- Jquery && Bootstrap CDN -->
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- DataTable CDN -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.6/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.13.6/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.13.6/js/dataTables.bootstrap4.min.js"></script>
  <!-- Font Awesome CDN -->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.2/css/all.min.css"
    integrity="sha512-z3gLpd7yknf1YoNbCzqRKc4qyor8gaKU1qmn+CShxbuBusANI9QpRohGBreCFkKxLhei6S9CQXFEbbKuqLg0DA=="
    crossorigin="anonymous" referrerpolicy="no-referrer" />
</head>

<body>
  <div class="container">
    <div class="text-center mt-2 mb-2">
      <h2>F120 - Quản trị Order</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="gPizzaTypeSelect">Loại Pizza</label>
        </div>
        <div class="col-sm-6">
          <select id="gPizzaTypeSelect" class="form-control">
            <option value="0">Chọn Loại Pizza</option>
          </select>
        </div>
        <div class="col-sm-3">
          <button id="btn-filter" class="btn btn-info">Lọc dữ liệu</button>
        </div>
      </div>
    </div>

    <div class="container">
      <table class="table table-bordered table-striped table-hover" id="order-table">
        <thead>
          <tr>
            <th>STT</th>
            <th>Mã order</th>
            <th>Loại Pizza</th>
            <th>Tên khách hàng</th>
            <th>Ngày đặt hàng</th>
            <th>Trạng thái</th>
            <th>Action</th>
          </tr>
        </thead>
      </table>
    </div>

    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      // mảng orders
      var gOrderObjects = [
        {
          "id": 2,
          "orderCode": "12456",
          "gPizzaTypeId": 20,
          "customerName": "Do Van Linh",
          "date": "13/01/2021",
          "status": "completed"
        },
        {
          "id": 3,
          "orderCode": "22456",
          "gPizzaTypeId": 10,
          "customerName": "Huynh Van Nam",
          "date": "13/01/2021",
          "status": "new"
        },
        {
          "id": 4,
          "orderCode": "22986",
          "gPizzaTypeId": 15,
          "customerName": "Do Thi Lan",
          "date": "14/01/2021",
          "status": "completed"
        },
        {
          "id": 5,
          "orderCode": "42086",
          "gPizzaTypeId": 10,
          "customerName": "Dinh Chau Ngoc",
          "date": "14/01/2021",
          "status": "completed"
        },
        {
          "id": 6,
          "orderCode": "56086",
          "gPizzaTypeId": 15,
          "customerName": "Dang Tien Minh",
          "date": "15/01/2021",
          "status": "new"
        },
        {
          "id": 7,
          "orderCode": "90081",
          "gPizzaTypeId": 20,
          "customerName": "Do Hong Quan",
          "date": "15/01/2021",
          "status": "inprogress"
        },
        {
          "id": 8,
          "orderCode": "67012",
          "gPizzaTypeId": 15,
          "customerName": "Bui Thanh Phuoc",
          "date": "15/01/2021",
          "status": "inprogress"
        }
      ];

      // mảng pizza Type
      var gPizzaType = [
        {
          typeId: 10,
          typeName: "Hải Sản"
        },
        {
          typeId: 15,
          typeName: "Bò bít tết"
        },
        {
          typeId: 20,
          typeName: "Thịt gà"
        }
      ];
      var gStt = 1
      var gTable = $("#order-table").DataTable({
        // Phân trang
        paging: true,
        // Tìm kiếm
        searching: false,
        // Sắp xếp
        ordering: false,
        // Số bản ghi phân trang
        lengthChange: false,
        columns: [
          { data: "STT" },
          { data: "orderCode" },
          { data: "gPizzaTypeId" },
          { data: "customerName" },
          { data: "date" },
          { data: "status" },
          { data: "action" },
        ],
        columnDefs: [
          {
            targets: 0,
            render: function () {
              return gStt++
            }
          },
          {
            targets: 2,
            render: renderPizza
          },
          {
            targets: 6,
            defaultContent: `
            <i style="cursor: pointer" class="fa-solid fa-pencil" data-toggle="tooltip" data-placement="top" title="Sửa"></i>
          <i style="cursor: pointer" class="fa-solid fa-trash-can" data-toggle="tooltip" data-placement="top" title="Xóa"></i>`
          }
        ]
      })
      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      $(document).ready(function () {
        onPageLoading()
        //Gán sự kiện nút filter
        $(document).on("click", "#btn-filter", function () {
          onBtnFilterClick()
        })
      })
      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      function onPageLoading() {
        displayDataToTable(gOrderObjects)
        loadDataToSelect()
      }
      // Hàm xử lý sự kiện nút lọc
      function onBtnFilterClick() {
        var vFilter = { typeId: -1 }
        // B1 Thu thập dữ liệu
        getDataToFilter(vFilter)
        // B2 Kiểm tra dữ liệu
        // B3 Xử lý Filter
        filterPizza(vFilter)

      }
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      // hàm trả về pizzaTypeName dựa vào typeId
      function getPizzaNameByTypeId(paramTypeId) {
        "use strict";
        var vPizzaTypeName = "";
        var vIndex = 0;
        var vIsTypeFound = false;
        while (!vIsTypeFound && vIndex < gPizzaType.length) {
          if (gPizzaType[vIndex].typeId === paramTypeId) {
            vIsTypeFound = true;
            vPizzaTypeName = gPizzaType[vIndex].typeName;
          }
          else {
            vIndex++;
          }
        }
        return vPizzaTypeName;
      }
      // Hàm hiển thị data
      function displayDataToTable(paramObject) {
        gTable.clear();
        gTable.rows.add(paramObject);
        gTable.draw();
      }
      // Hàm render RoleId thành RoleName
      function renderPizza(paramPizzaId) {
        var vVitriHienTai = 0
        var vPizzaObject = null
        var vTimThayPizza = false
        while (vTimThayPizza == false && vVitriHienTai < gPizzaType.length) {
          if (gPizzaType[vVitriHienTai].typeId == paramPizzaId) {
            vTimThayPizza = true
            vPizzaObject = gPizzaType[vVitriHienTai].typeName

          }
          vVitriHienTai++
        }
        return vPizzaObject
      }
      // Hàm load dữ liệu vào select
      function loadDataToSelect() {
        var vPizzaSelect = $("#gPizzaTypeSelect");
        for (let bI = 0; bI < gPizzaType.length; bI++) {
          var bOption = `<option value="${gPizzaType[bI].typeId}">${gPizzaType[bI].typeName}</option>`
          vPizzaSelect.append(bOption)
        }
      }
      // Hàm xử lý filter
      function filterPizza(paramObject) {
        var vPizzaResult = []
        // Thực hiện việc lọc
        vPizzaResult = gOrderObjects.filter(function (paramOrder) {
          return (paramObject.typeId == 0 || paramOrder.gPizzaTypeId == paramObject.typeId)
        })
        displayDataToTable(vPizzaResult)
      }
      // Hàm thu thập dữ liệu để lọc
      function getDataToFilter(paramObject) {
        paramObject.typeId = $.trim($("#gPizzaTypeSelect").val())
      }
    </script>
</body>

</html>